#include <bits/stdc++.h>
#include <string>

using namespace std;

typedef unsigned long long ull;
typedef unsigned int uint;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

typedef vector<ull> word;
uint const WORD = 64u, CHAR = 6u;

inline ull parse(char c) {
    if (c < '0') return c - '#';
    if (c <= '9') return c - '0' + 2;
    if (c <= 'Z') return c - 'A' + 12;
    return c - 'a' + 38;
}

inline ull cover(uint bits) {
    if (bits == WORD) return ~0ull;
    return (1ull << bits) - 1ull;
}

word parse(string const &s) {
    word w{0};
    uint bx = 0;
    for (char c: s) {
        ull mask = parse(c);
        if (bx + CHAR <= WORD) {
            w.back() = w.back() << CHAR | mask;
            bx += CHAR;
        } else {
            uint lx = WORD - bx, rx = CHAR - lx;
            w.back() = w.back() << lx | mask >> rx;
            w.push_back(mask & cover(rx));
            bx = rx;
        }
    }
    return w;
}

bool check(word const &w1, word const &w2, uint shift, uint tail) {
    auto len = [&](int i) {
        return i < w1.size() - 1 ? WORD : tail;
    };
    uint wx = shift / WORD, bx = shift % WORD;
    for (int i = 0; i < w2.size(); i++) {
        ull mask = 0;
        uint lw = i + wx, lb = bx;
        if (lw >= w2.size()) {
            lw -= w2.size();
            lb += (WORD - tail);
        }
        while (lb > len(lw)) {
            lb -= len(lw);
            lw = (lw + 1) % w2.size();
        }
        uint cur = 0u, r = len(i);
        while (cur < r) {
            uint llw = len(lw), d = min(llw - lb, r - cur);
            uint shr = llw - lb - d;
            cur += d;
            if (d < WORD) mask <<= d;
            mask |= (w1[lw] >> shr) & cover(d);
            lb += d;
            if (lb == llw) {
                lb = 0;
                lw = (lw + 1) % w2.size();
            }
        }
        if (w2[i] != mask) return false;
    }
    return true;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(uint, k, m)
    uint len = CHAR * k, tail = len % WORD;
    if (tail == 0) tail = WORD;

    while (m--) {
        in(string, c_raw, p_raw);
        word c = parse(c_raw), p = parse(p_raw);
        bool found = false;

        for (uint shift = 0; shift < len; shift++) {
            if (check(c, p, shift, tail)) {
                cout << shift << '\n';
                found = true;
                break;
            }
        }

        if (!found) cout << -1 << '\n';
    }

}