#include <bits/stdc++.h>
#include <string>

using namespace std;

typedef unsigned long long ull;
typedef unsigned int uint;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

typedef vector<bool> word;
uint const CHAR = 6u;

inline uint parse(char c) {
    if (c < '0') return c - '#';
    if (c <= '9') return c - '0' + 2;
    if (c <= 'Z') return c - 'A' + 12;
    return c - 'a' + 38;
}

word parse(string const &s) {
    word w;
    for (char c: s) {
        uint mask = parse(c);
        for (uint t = 0; t < CHAR; t++) w.push_back((mask >> (CHAR - 1u - t)) & 1u);
    }
    return w;
}

bool check(word const &w1, word const &w2, uint shift) {
    for (int i = 0; i < w1.size(); i++) {
        int j = (i + shift) % w1.size();
        if (w2[i] ^ w1[j]) return false;
    }
    return true;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(uint, k, m)
    uint len = CHAR * k;

    while (m--) {
        in(string, c_raw, p_raw)
        word c = parse(c_raw), p = parse(p_raw);
        bool found = false;

        for (uint shift = 0; shift < len; shift++) {
            if (check(c, p, shift)) {
                cout << shift << '\n';
                found = true;
                break;
            }
        }

        if (!found) cout << -1 << '\n';
    }

}