/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
 
void solve() {
	auto read = [&](int n) {
		string s;
		cin >> s;
		vector<int> a(n);
		for (int i = 0; i < n; i++) {
			if (s[i] == '#')
				a[i] = 0;
			else if (s[i] == '$')
				a[i] = 1;
			else if ('0' <= s[i] && s[i] <= '9')
				a[i] = 2 + (s[i] - '0');
			else if ('A' <= s[i] && s[i] <= 'Z')
				a[i] = 12 + (s[i] - 'A');
			else
				a[i] = 12 + 26 + (s[i] - 'a');
		}
		vector<ll> aa((n + 9) / 10, 0);
		for (int i = 0; i * 10 < n; i++) {
			for (int j = 10 * i; j < 10 * i + 10 && j < n; j++) {
				aa[i] = 64 * aa[i] + a[j];
			}
		}
		return aa;
	};
	int n, m;
	cin >> n >> m;
	vector<ll> mx((n + 9) / 10);
	for (int i = 0; i * 10 < n; i++) {
		mx[i] = 1;
		for (int j = 10 * i; j < 10 * i + 10 && j < n; j++)
			mx[i] *= 64;
	}
	int nn = (n + 9) / 10;
	for (int j = 0; j < m; j++) {
		vector<ll> a = read(n);
		vector<ll> b = read(n);
		vector<ll> c = a;
		int ans = 0;
		while (c != b && (ans == 0 || c != a)) {
			for (int i = 0; i < nn; i++) {
				c[i] *= 2;
			}
			for (int i = 1; i < nn; i++) {
				if (c[i] >= mx[i]) {
					c[i] -= mx[i];
					c[i - 1]++;
				}
			}
			if (c[0] >= mx[0]) {
				c[0] -= mx[0];
				c[nn - 1]++;
			}
			ans++;
		}
		if (c == b) {
			cout << ans << "\n";
		} else {
			cout << -1 << "\n";
		}
	}
}
 
 
int main() {
#ifdef LOCAL
	clock_t start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}