using namespace std;

//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <tuple>
#include <map>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second


struct SegTreeDP {
    typedef pair<pair<ll, int>, pair<int, int>> value_t;
    value_t neitral_v = mp(mp(0, -1), mp(-1, -1));

    static value_t sum_f(const value_t a, const value_t b) {
        if (a.X.Y == -1 || b.X.Y == -1) {
            return a.X.Y == -1 ? b : a;
        }
        return a.X.X >= b.X.X ? a : b;
    }

    SegTreeDP(const vector<value_t> &a) : nn(pow(2, floor(log2((int) a.size())) + 1)), ar(nn * 2, neitral_v) {
        fori(i, a.size()) {
            ar[nn - 1 + i] = a[i];
        }
        for (int i = nn - 2; i >= 0; --i) {
            ar[i] = sum_f(ar[i * 2 + 1], ar[i * 2 + 2]);
        }
    }

    value_t ssum(int l, int r) {
        return ssum(l, r, 0, 0, nn);
    }

    value_t ssum(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return neitral_v;
        }
        if (l <= lx && rx <= r) {
            return ar[x];
        }
        int m = (lx + rx) / 2;
        return sum_f(ssum(l, r, x * 2 + 1, lx, m), ssum(l, r, x * 2 + 2, m, rx));
    }

    int nn;
    vector<value_t> ar;
};

typedef pair<ll, ll> point;
typedef pair<point, point> vect; // a->b
typedef tuple<ll, int, int, int> edge;
typedef double vangle;
typedef pair<vangle, pair<ll, int>> cleg; // angle<vu, us>, dist(v, u), v_number

vect normal(const vect v) { // vect a->b -> vect c->b
    return mp(mp(v.Y.X - (v.Y.Y - v.X.Y), v.Y.Y + (v.Y.X - v.X.X)), v.Y);
}

ll dist(const point a, const point b) {
    return sqr(a.first - b.first) + sqr(a.second - b.second);
}

ll scvmp(const point a1, const point a2, const point b1, const point b2) {
    ll x1 = a2.X - a1.X;
    ll x2 = b2.X - b1.X;
    ll y1 = a2.Y - a1.Y;
    ll y2 = b2.Y - b1.Y;
    return x1 * x2 + y1 * y2;
}

ll vectmp(const point a1, const point a2, const point b1, const point b2) {
    ll x1 = a2.X - a1.X;
    ll x2 = b2.X - b1.X;
    ll y1 = a2.Y - a1.Y;
    ll y2 = b2.Y - b1.Y;
    return x1 * y2 - x2 * y1;
}

// angle (a1->a2)^(b1->b2)
vangle angle(const point a1, const point a2, const point b1, const point b2) {
    return atan2(static_cast<double>(vectmp(a1, a2, b1, b2)),
                 static_cast<double>(scvmp(a1, a2, b1, b2)));
}

bool is_angle_in_pid4_0(const point a1, const point a2, const point b1, const point b2) {
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return vectmpv < 0 && -vectmpv < scvmp(a1, a2, b1, b2);
}

bool is_angle_in_0_pid4(const point a1, const point a2, const point b1, const point b2) {
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return 0 < vectmpv && vectmpv < scvmp(a1, a2, b1, b2);
}

bool is_angle_le_pid4(const point a1, const point a2, const point b1, const point b2) {
    ll scvmpv = scvmp(a1, a2, b1, b2);
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return vectmpv <= 0 || 0 < vectmpv && vectmpv < scvmpv;
}

bool is_angle_leq_npid4(const point a1, const point a2, const point b1, const point b2) {
    ll scvmpv = scvmp(a1, a2, b1, b2);
    ll vectmpv = vectmp(a1, a2, b1, b2);
    return scvmpv <= 0 && vectmpv <= 0 || 0 < scvmpv && scvmpv <= -vectmpv;
}

bool is_angle_0(const point a1, const point a2, const point b1, const point b2) {
    return vectmp(a1, a2, b1, b2) == 0 && scvmp(a1, a2, b1, b2) > 0;
}

const double PI = acos(-1.0);
const double PId2 = asin(1.0);
const double PId4 = atan(1.0);

int out_edge_bin_search_l(const vector<SegTreeDP::value_t> &a, const vector<point> &pts,
                          const point p, const point &u) {
    int l = -1, r = (int) a.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (is_angle_leq_npid4(u, p, pts[a[m].X.Y], u)) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

int out_edge_bin_search_r(const vector<SegTreeDP::value_t> &a, const vector<point> &pts,
                          const point p, const point &u) {
    int l = -1, r = (int) a.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (is_angle_le_pid4(u, p, pts[a[m].X.Y], u)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

#define vs(v) "(" << v.X << "," << v.Y << ")"
#undef db
#define db(x) 0;
#undef db_
#define db_(x) 0;

void solver() {
    int n, m, sn;
    cin >> n >> m >> sn;
    --sn;
    vector <point> points(n);
    vector < pair < pair < ll, int >, point >> points_dist(n); // dist, number, x, y
    fori(i, n) {
        cin >> points[i].X;
        cin >> points[i].Y;
    }
    point s = points[sn];
    fori(i, n) {
        points_dist[i].X.X = dist(s, points[i]);
        points_dist[i].X.Y = i;
    }
    vector < vector < pair < double, int>>> out_edges(n);
    vector <vector<cleg>> legs(n); // angle, edges dist, v_number
    vect spntup = mp(s, mp(s.X, s.Y - 1));
    vect spointdown = mp(s, mp(s.X, s.Y + 1));
    fori(i, m) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        if (points_dist[v].X.X < points_dist[u].X.X) {
            swap(u, v); // must be dist(u, s) < dist(v, s)
        }
        if (u == sn) {
            legs[sn].emplace_back(angle(spntup.X, spntup.Y, points[v], points[u]), mp(dist(points[v], points[u]), v));
        } else {
            legs[u].emplace_back(angle(points[u], s, points[v], points[u]), mp(dist(points[v], points[u]), v));
        }
        out_edges[v].emplace_back(angle(points[v], points[u], points[v], s), u);
    }
    sort(rall(points_dist));
    map < pair < int, int >, pair < pair < ll, int >, pair < int, int>>> dp;

    fori(j, n) {
        int i = points_dist[j].X.Y;
        db("see on " << i + 1)
        point &u = points[i];
        if (sn == i || legs[i].empty()) { continue; }
        sort(all(legs[i]));
        queue <pair<ll, int>> befq, aftq;
        set <pair<ll, int>> befs, afts;
        stack <pair<ll, int>> aftbuf;
        int befcnt = 1;

        // смотрю входящие ребра, чтобы +- для каждого ребра
        vector <SegTreeDP::value_t> good_edgs;
        fori(k, legs[i].size()) {
            db("try? " << k << "(" << legs[i][k].Y.Y + 1 << ") " << befq.size() << " " << aftq.size())
            int vn = legs[i][k].Y.Y;
            point v = points[vn];
            if (!aftbuf.empty() && !is_angle_0(v, u, points[aftbuf.top().second], u)) {
                while (!aftbuf.empty()) {
                    aftq.push(aftbuf.top());
                    afts.insert(aftbuf.top());
                    aftbuf.pop();
                }
            }
            while (!befq.empty()) {
                if (!is_angle_in_0_pid4(v, u, points[befq.front().Y], u)/*xx <= 0 || xx >= PId4*/) {
                    befs.erase(befq.front());
                    befq.pop();
                } else { break; }
            }
            befcnt = max(befcnt, k + 1);
            while (befcnt < legs[i].size()) {
                if (is_angle_0(v, u, points[legs[i][befcnt].Y.Y], u)) {
                    ++befcnt;
                    continue;
                }
                if (!is_angle_in_0_pid4(v, u, points[legs[i][befcnt].Y.Y], u) /*xx <= 0 || xx >= PId4*/) { break; }
                befq.push(legs[i][befcnt % legs[i].size()].Y);
                befs.insert(legs[i][befcnt % legs[i].size()].Y);
                ++befcnt;
            }
            while (!aftq.empty()) {
                if (is_angle_in_pid4_0(v, u, points[aftq.front().Y], u)/*-PId4 < xx && xx < 0*/) { break; }
                afts.erase(aftq.front());
                aftq.pop();
            }

            if (abs(legs[i][k].first) < PId4) {
                db("?! " << k << "(" << legs[i][k].Y.Y + 1 << ") " << befs.size() << " " << afts.size())
                if (!befq.empty() && !aftq.empty()) {
                    db("?try " << k << "(" << legs[i][k].Y.Y + 1 << ") " << befs.begin()->X << " " << afts.begin()->X)
                }
                if (!befq.empty() && !aftq.empty()
                    && befs.begin()->first <= dist(v, u) && afts.begin()->first <= dist(v, u)) {
                    db("+dp " << k << "(" << legs[i][k].Y.Y + 1 << ") " << befs.begin()->Y << " " << afts.begin()->Y)
                    ll dp_v = dist(points[i], v);
                    if (dp.find(mp(vn, i)) != dp.end()) { dp_v += dp[mp(vn, i)].X.X; }
                    good_edgs.emplace_back(mp(dp_v, vn), mp(befs.begin()->Y, afts.begin()->Y));
                    db("+ " << i + 1 << " " << vn + 1 << " " << dp_v)
                }
            }
            aftbuf.push(legs[i][k].Y);
        }
        if (good_edgs.empty()) { continue; }
        if (out_edges[i].empty()) { continue; }
        SegTreeDP stdp(good_edgs);
        sort(all(out_edges[i]));
        for (auto ppn : out_edges[i]) {
            point &p = points[ppn.Y];
            int l = out_edge_bin_search_l(good_edgs, points, p, u);
            int r = out_edge_bin_search_r(good_edgs, points, p, u);
            if (r - l < 0) {
                continue;
            }
            auto stans = stdp.ssum(l, r + 1);
            db("doans " << l << " " << r << " = " << stans.X.X << " for " << i + 1 << "," << ppn.Y + 1)
            dp[mp(i, ppn.Y)] = stans;
        }
    }

    db("start")
    point &u = s;
    pair <pair<ll, int>, pair<int, int>> dp_v(mp(0LL, -1), mp(-1, -1));
    if (legs[sn].size() > 1) {// стартовая вершина
        sort(all(legs[sn]));
        queue <pair<ll, int>> befq, aftq;
        set <pair<ll, int>> befs, afts;
        stack <pair<ll, int>> aftbuf;
        int befcnt = 1;
        for (int i = 1; i < legs[sn].size(); ++i) {
            point v = points[legs[sn][0].Y.Y];
            int qn = legs[sn][i].Y.Y;
            if (is_angle_in_pid4_0(v, s, points[qn], s) /*-PId4 < xx && xx < 0*/) {
                afts.insert(legs[sn][i].Y);
                aftq.push(legs[sn][i].Y);
            }
        }
        db("prep " << vs(aftq.front()))
        fori(k, legs[sn].size()) {
            int vn = legs[sn][k].Y.Y;
            db("k = " << k << "(S<-" << vn + 1 << ")")
            point v = points[vn];
            if (!aftbuf.empty() && !is_angle_0(v, s, points[aftbuf.top().second], s)) {
                while (!aftbuf.empty()) {
                    aftq.push(aftbuf.top());
                    afts.insert(aftbuf.top());
                    aftbuf.pop();
                }
            }
            while (!befq.empty()) {
                if (!is_angle_in_0_pid4(v, s, points[befq.front().Y], s)) {
                    befs.erase(befq.front());
                    befq.pop();
                } else { break; }
            }
            befcnt = max(befcnt, k + 1);
            db("befcnt=" << befcnt)
            while (befcnt < legs[sn].size() + k) {
                db("befq befcnt=" << befcnt << " " << vs(legs[sn][befcnt % legs[sn].size()].Y))
                if (is_angle_0(v, s, points[legs[sn][befcnt % legs[sn].size()].Y.Y], s)) {
                    ++befcnt;
                    continue;
                }
                if (!is_angle_in_0_pid4(v, s, points[legs[sn][befcnt % legs[sn].size()].Y.Y], s)) {
                    break; /*xx <= 0 || xx >= PId4*/
                }
                befq.push(legs[sn][befcnt % legs[sn].size()].Y);
                befs.insert(legs[sn][befcnt % legs[sn].size()].Y);
                ++befcnt;
            }
            while (!aftq.empty()) {
                if (is_angle_in_pid4_0(v, s, points[aftq.front().Y], s)/*-PId4 < xx && xx < 0*/) {
                    break;
                }
                afts.erase(aftq.front());
                aftq.pop();
            }
            db("?? " << k << "(" << legs[sn][k].Y.Y + 1 << ") " << befq.size() << " " << aftq.size())

            if (!befq.empty() && !aftq.empty()) {
                db("?dp " << k << "(" << legs[sn][k].Y.Y << ") " << befs.begin()->X << " " << afts.begin()->X)
            }
            if (!befq.empty() && !aftq.empty()
                && befs.begin()->first <= dist(v, s) && afts.begin()->first <= dist(v, s)) {
                db("+dp " << k << "(" << legs[sn][k].Y.Y << ") " << befs.begin()->Y << " " << afts.begin()->Y)
                pair <pair<ll, int>, pair<int, int>> cur_dp_v;
                cur_dp_v.X.X = dist(v, s);

                if (dp.find(mp(vn, sn)) != dp.end()) { cur_dp_v.X.X += dp[mp(vn, sn)].X.X; }
                cur_dp_v.X.Y = vn;
                cur_dp_v.Y.X = befs.begin()->second;
                cur_dp_v.Y.Y = afts.begin()->second;
                if (cur_dp_v.X.X > dp_v.X.X) {
                    dp_v = cur_dp_v;
                }
            }
            aftbuf.push(legs[sn][k].Y);
        }
    }

    auto cdp = dp_v;
    int nwp = sn;
    vector <tuple<int, int, int>> ans;
    while (nwp >= 0 && cdp.X.Y > -1) {
        ans.emplace_back(cdp.Y.X + 1, cdp.X.Y + 1, cdp.Y.Y + 1);
        int tt = nwp;
        nwp = cdp.X.Y;
        db(vs(mp(tt, nwp)))
        auto ff = mp(nwp, tt);
        if (dp.find(ff) == dp.end())
            break;
        cdp = dp[mp(nwp, tt)];
    }
    cout << ans.size() << " " << dp_v.X.X << "\n";
    for (auto pp : ans) {
        cout << get<0>(pp) << " " << get<1>(pp) << " " << get<2>(pp) << "\n";
    }
}

int main() {
    fastio;
    solver();
}
