using namespace std;

#include <bits/stdc++.h>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

struct SegTree {
    typedef pair<ll, int> value_t;
    value_t neitral_v = mp(0, -1);

    static value_t sum_f(const value_t a, const value_t b) {
        if (a.Y == -1 || b.Y == -1) {
            return a.Y == -1 ? b : a;
        }
        return a.X <= b.X ? a : b;
    }

    SegTree(const vector<value_t> &a) : nn(pow(2, floor(log2(static_cast<int>( a.size()))) + 1)),
                                        ar(nn * 2, neitral_v) {
        fori(i, a.size()) {
            ar[nn - 1 + i] = a[i];
        }
        for (int i = nn - 2; i >= 0; --i) {
            ar[i] = sum_f(ar[i * 2 + 1], ar[i * 2 + 2]);
        }
    }

    value_t ssum(int l, int r) {
        return ssum(l, r, 0, 0, nn);
    }

    value_t ssum(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return neitral_v;
        }
        if (l <= lx && rx <= r) {
            return ar[x];
        }
        int m = (lx + rx) / 2;
        return sum_f(ssum(l, r, x * 2 + 1, lx, m), ssum(l, r, x * 2 + 2, m, rx));
    }

    int nn;
    vector<value_t> ar;
};

struct SegTreeDP {
    typedef pair<pair<ll, int>, pair<int, int>> value_t;
    value_t neitral_v = mp(mp(0, -1), mp(-1, -1));

    static value_t sum_f(const value_t a, const value_t b) {
        if (a.X.Y == -1 || b.X.Y == -1) {
            return a.X.Y == -1 ? b : a;
        }
        return a.X.X >= b.X.X ? a : b;
    }

    SegTreeDP(const vector<value_t> &a) : nn(pow(2, floor(log2((int) a.size())) + 1)), ar(nn * 2, neitral_v) {
        fori(i, a.size()) {
            ar[nn - 1 + i] = a[i];
        }
        for (int i = nn - 2; i >= 0; --i) {
            ar[i] = sum_f(ar[i * 2 + 1], ar[i * 2 + 2]);
        }
    }

    value_t ssum(int l, int r) {
        return ssum(l, r, 0, 0, nn);
    }

    value_t ssum(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return neitral_v;
        }
        if (l <= lx && rx <= r) {
            return ar[x];
        }
        int m = (lx + rx) / 2;
        return sum_f(ssum(l, r, x * 2 + 1, lx, m), ssum(l, r, x * 2 + 2, m, rx));
    }

    int nn;
    vector<value_t> ar;
};

typedef pair<ll, ll> point;
typedef pair<point, point> vect; // a->b
typedef tuple<ll, int, int, int> edge;
typedef double vangle;
typedef pair<vangle, pair<ll, int>> cleg; // angle<vu, us>, dist(v, u), v_number

vect normal(const vect v) { // vect a->b -> vect c->b
    return mp(mp(v.Y.X - (v.Y.Y - v.X.Y), v.Y.Y + (v.Y.X - v.X.X)), v.Y);
}

ll dist(const point a, const point b) {
    return sqr(a.first - b.first) + sqr(a.second - b.second);
}

ll dist(const vect a) {
    return dist(a.X, a.Y);
}

ll scvmp(const point a1, const point a2, const point b1, const point b2) {
    ll x1 = a2.X - a1.X;
    ll x2 = b2.X - b1.X;
    ll y1 = a2.Y - a1.Y;
    ll y2 = b2.Y - b1.Y;
    return x1 * x2 + y1 * y2;
}

ll vectmp(const point a1, const point a2, const point b1, const point b2) {
    ll x1 = a2.X - a1.X;
    ll x2 = b2.X - b1.X;
    ll y1 = a2.Y - a1.Y;
    ll y2 = b2.Y - b1.Y;
    return x1 * y2 - x2 * y1;
}

// angle (a1->a2)^(b1->b2)
vangle angle(const point a1, const point a2, const point b1, const point b2) {
    return atan2(static_cast<double>(vectmp(a1, a2, b1, b2)),
                 static_cast<double>(scvmp(a1, a2, b1, b2)));
}

const double PI = acos(-1.0);
const double PId2 = asin(1.0);
const double PId4 = atan(1.0);

int edge_bin_search_l(const vector<cleg> &a, const vector<point> &pts,
                      const point u, int l, int r, const vect &vu) {
    while (r - l > 1) {
        int m = (l + r) / 2;
        double xx = angle(vu.X, vu.Y, pts[a[m].Y.Y], u);
        if (-PId4 < xx) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

int edge_bin_search_r(const vector<cleg> &a, const vector<point> &pts,
                      const point u, int l, int r, vect vu) {
    while (r - l > 1) {
        int m = (l + r) / 2;
        double xx = angle(vu.X, vu.Y, pts[a[m].Y.Y], u);
        if (xx < PId4) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

int out_edge_bin_search_l(const vector<SegTreeDP::value_t> &a, const vector<point> &pts,
                          const point p, const point &u) {
    int l = -1, r = (int) a.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (angle(u, p, pts[a[m].X.Y], u) <= -PId4) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

int out_edge_bin_search_r(const vector<SegTreeDP::value_t> &a, const vector<point> &pts,
                          const point p, const point &u) {
    int l = -1, r = (int) a.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (angle(u, p, pts[a[m].X.Y], u) < PId4) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

#define vs(v) "(" << v.X << "," << v.Y << ")"
#undef db
#define db(x) 0;
#undef db_
#define db_(x) 0;

void solver() {
    int n, m, sn;
    cin >> n >> m >> sn;
    --sn;
    vector <point> points(n);
    vector < pair < pair < ll, int >, point >> points_dist(n); // dist, number, x, y
    fori(i, n) {
        cin >> points[i].X;
        cin >> points[i].Y;
    }
    point s = points[sn];
    fori(i, n) {
        points_dist[i].X.X = dist(s, points[i]);
        points_dist[i].X.Y = i;
    }
    vector < vector < pair < double, int>>> out_edges(n);
//    vector <vector<int>> nedges(n + 1);
    vector <vector<cleg>> legs(n); // angle, edges dist, v_number
    vect spointup = mp(s, mp(s.X, s.Y - 1));
    vect spointdown = mp(s, mp(s.X, s.Y + 1));
    fori(i, m) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        if (points_dist[v].X.X < points_dist[u].X.X) {
            swap(u, v); // must be dist(u, s) < dist(v, s)
        }
        if (u == sn) {
            legs[sn].emplace_back(angle(spointup.X, spointup.Y, points[v], points[u]),
                                  mp(dist(points[v], points[u]), v));
//            slegs[1].emplace_back(angle(spointdown.X, spointdown.Y, points[v], points[u]),
//                                  mp(dist(points[v], points[u]), v));
        } else {
            legs[u].emplace_back(angle(points[u], s, points[v], points[u]),
                                 mp(dist(points[v], points[u]), v));
        }
        out_edges[v].emplace_back(angle(points[v], points[u], points[v], s), u);
    }
    sort(rall(points_dist));
//    vector < pair < pair < ll, int >, pair < int, int>>> dp(n, mp(mp(-1, 0), mp(0, 0)));
    map < pair < int, int >, pair < pair < ll, int >, pair < int, int>>> dp;
    fori(j, n) {
        int i = points_dist[j].X.Y;
        point &u = points[i];
        if (sn == i || legs[i].empty()) { continue; }
        sort(all(legs[i]));
        vector <pair<ll, int>> starr(legs[i].size());
        fori(k, legs[i].size()) { starr[k] = legs[i][k].Y; }
        SegTree st(starr);
//        for (auto x : legs[i]) {
//            db("- " << x.Y.Y + 1 << " " << x.X << " " << x.Y.X << "\n")
//        }

        // смотрю входящие ребра, чтобы +- для каждого ребра
        vector <SegTreeDP::value_t> good_edgs;
        fori(k, legs[i].size()) {
            int vn = legs[i][k].Y.Y;
            point v = points[vn];
            if (abs(legs[i][k].first) < PId4) {
                // todo: на самом деле надо вместо k использовать k - delta или k + gamma, такие, чтобы выбираемы ветки были не параллельны стволу
                int l = edge_bin_search_l(legs[i], points, u, -1, k, vect(v, u));
                int r = edge_bin_search_r(legs[i], points, u, k, legs[i].size(), vect(v, u));
                if (l == k || r == k) {
                    continue;
                }
                auto lmd = st.ssum(l, k);
                auto rmd = st.ssum(k + 1, r + 1);
                if (lmd.first >= dist(u, v) || rmd.first >= dist(u, v)) {
                    continue;
                }
                ll dp_v = dist(points[i], v);
                if (dp.find(mp(vn, i)) != dp.end()) { dp_v += dp[mp(vn, i)].X.X; }
                good_edgs.emplace_back(mp(dp_v, vn), mp(lmd.Y, rmd.Y));
                db("+ " << i << " " << vn + 1 << " " << l << " " << k << " " << r)
            }
        }
        if (good_edgs.empty()) { continue; }
        if (out_edges[i].empty()) { continue; }
        SegTreeDP stdp(good_edgs);
        sort(all(out_edges[i]));
        for (auto ppn : out_edges[i]) {
            point &p = points[ppn.Y];
            fori(k, good_edgs.size()) {
                db(good_edgs[k].X.Y << "->" << i << "->" << ppn.Y << " " <<
                                    angle(u, p, points[good_edgs[k].X.Y], u))
            }
            int l = out_edge_bin_search_l(good_edgs, points, p, u);
            int r = out_edge_bin_search_r(good_edgs, points, p, u);
            if (r - l < 0) {
                continue;
            }
            db(l << " " << r)
            auto stans = stdp.ssum(l, r + 1);
            dp[mp(i, ppn.Y)] = stans;
        }
    }
    point &u = s;
    pair <pair<ll, int>, pair<int, int>> dp_v(mp(0LL, -1), mp(-1, -1));

    if (legs[sn].size() > 1) {// стартовая вершина
        sort(all(legs[sn]));
        queue <pair<ll, int>> befq, aftq;
        set <pair<ll, int>> befs, afts;
        stack <pair<ll, int>> aftbuf;
        int befcnt = 1;
        for (int i = 1; i < legs[sn].size(); ++i) {
            point v = points[legs[sn][0].Y.Y];
            int qn = legs[sn][i].Y.Y;
            double xx = angle(v, s, points[qn], s);
            if (-PId4 < xx && xx < 0) {
                afts.insert(legs[sn][i].Y);
                aftq.push(legs[sn][i].Y);
            }
        }
        fori(k, legs[sn].size()) {
            int vn = legs[sn][k].Y.Y;
            db("k = " << k << "(" << vn + 1 << ")")
            point v = points[vn];
            if (!aftbuf.empty() && angle(v, s, points[aftbuf.top().second], s) != 0) {
                while (!aftbuf.empty()) {
                    aftq.push(aftbuf.top());
                    afts.insert(aftbuf.top());
                    aftbuf.pop();
                }
            }
            while (!befq.empty()) {
                double xx = angle(v, s, points[befq.front().Y], s);
                if (xx <= 0 || xx >= PId4) {
                    befs.erase(befq.front());
                    befq.pop();
                } else {
                    break;
                }
            }
            befcnt = max(befcnt, k + 1);
            while (befcnt < legs[sn].size() + k) {
                double xx = angle(v, s, points[legs[sn][befcnt % legs[sn].size()].Y.Y], s);
//                db("d+ " << vn + 1 << " " << legs[sn][befcnt % legs[sn].size()].Y.Y + 1 << " "
//                         << angle(v, s, points[legs[sn][befcnt % legs[sn].size()].Y.Y], s))
                if (xx <= 0 || xx >= PId4) {
                    break;
                }
                befq.push(legs[sn][befcnt % legs[sn].size()].Y);
                befs.insert(legs[sn][befcnt % legs[sn].size()].Y);
                ++befcnt;
            }
            while (!aftq.empty()) {
                double xx = angle(v, s, points[aftq.front().Y], s);
                if (-PId4 < xx && xx < 0) {
                    break;
                }
                afts.erase(aftq.front());
                aftq.pop();
            }
            db("?? " << k << "(" << legs[sn][k].Y.Y + 1 << ") " << befq.size() << " " << aftq.size())

            if (!befq.empty() && !aftq.empty()) {
                db("?dp " << k << "(" << legs[sn][k].Y.Y << ") " << befs.begin()->X << " " << afts.begin()->X)
            }
            if (!befq.empty() && !aftq.empty()
                && befs.begin()->first < dist(v, s) && afts.begin()->first < dist(v, s)) {
                db("+dp " << k << "(" << legs[sn][k].Y.Y << ") " << befs.begin()->Y << " " << afts.begin()->Y)
                pair <pair<ll, int>, pair<int, int>> cur_dp_v;
                cur_dp_v.X.X = dist(v, s);

                if (dp.find(mp(vn, sn)) != dp.end()) { cur_dp_v.X.X += dp[mp(vn, sn)].X.X; }
                cur_dp_v.X.Y = vn;
                cur_dp_v.Y.X = befs.begin()->second;
                cur_dp_v.Y.Y = afts.begin()->second;
                if (cur_dp_v.X.X > dp_v.X.X) {
                    dp_v = cur_dp_v;
                }
            }

            aftbuf.push(legs[sn][k].Y);
        }
    }

    auto cdp = dp_v;
    int nwp = sn;
    vector <tuple<int, int, int>> ans;
    while (nwp >= 0 && cdp.X.Y > -1) {
        ans.emplace_back(cdp.Y.X + 1, cdp.X.Y + 1, cdp.Y.Y + 1);
        int tt = nwp;
        nwp = cdp.X.Y;
        db(vs(mp(tt, nwp)))
        auto ff = mp(nwp, tt);
        if (dp.find(ff) == dp.end())
            break;
        cdp = dp[mp(nwp, tt)];
    }
    cout << ans.size() << " " << dp_v.X.X << "\n";
    for (auto pp : ans) {
        cout << get<2>(pp) << " " << get<1>(pp) << " " << get<0>(pp) << "\n";

    }
//    ans[1].pb(nwp);
//    fori(j, 3) {
//        if (j != 1) {
//            cout << " ";
//        }
//        fori(i, ans[j].size()) {
//            cout << ans[j][i] + 1 << " ";
//        }
//        cout << "\n";
//    }
}

int main() {
#ifdef _DEBUG_INPUT_FILE
    freopen("test.in", "r", stdin);
#endif
    solver();
}