#include "testlib.h"


#include <iostream>
#include <string>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <cmath>
#include <stack>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <algorithm>
#include <utility>
#include <cstdlib>
#include <cstring>

using namespace std;

/*
1 & ? & $n \le 3$ &
2 & ? & $n \le 10$
3 & ? & массив~--- это перестановка
4 & ? & все числа в массиве различны и неотрицательны
5 & ? & $\exists\ i\ |\ a_i = 0$
6 & ? & каждое число в массиве встречается дважды
7 & ? & нет дополнительных ограничений
 */

int max_a = 1000000000;
int main(int argc, char* argv[]) {

    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    cout << n * 2 << "\n";
    vector<int> a(n * 2);
    rnd.next(1, 3);
    set<int> s;
    int hasZero = atoi(argv[3]);
    int hasAns = atoi(argv[2]);
    int i = 0;
    if (hasZero) {
        s.insert(0);
        i++;
    }
    for (; i < n; i++) {
        int x = rnd.next(1, max_a);
        while (s.find(x) != s.end()) {
            x = rnd.next(1, max_a);
        }
        s.insert(x);
        a[i] = x;
        a[i + n] = x;
    }
    sort(a.begin(), a.end());
    n *= 2;
    if (hasAns) {
        vector<int> cur = a;
        a.assign(n, 0);
        int l = rnd.next(0, n - 1);
        int r = l + 1;
        for (int i = 0; i < n; i++) {
            int rn = rnd.next(0, 1);
            if (rn && r != n || l == -1) {
                a[r] = cur[i];
                r++;
            } else {
                a[l] = cur[i];
                l--;
            }
        }
    } else {
        shuffle(a.begin(), a.end());
    }
    map<int, int> mp;
    for (int i = 0; i < n; i++) {
        mp[a[i]] = i;
    }
    for (int i = 0; i < n; i++) {
        if (rnd.next(0, 1) && mp[a[i]] != i) {
            a[mp[a[i]]] *= -1;
            a[i] *= -1;
            mp[a[i]] = mp[-a[i]];
        }
    }
    for (int i = 0; i < n; i++) {
        cout << a[i];
        if (i != n - 1) {
            cout << ' ';
        } else {
            cout << '\n';
        }
    }
    return 0;
}
