#include "testlib.h"

using namespace std;


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    auto n = opt<int>("n");
    auto wS = -3000, wM = 3000, wC = rnd.next(-20, 20);
    auto pt = rnd.partition(3, 200'000);
    int sumQ = pt[0], changeQ = pt[1], modifyQ = pt[2];
    cout << n << " " << sumQ + changeQ + modifyQ << "\n";
    
    int val = (1 << (rnd.next(0, 29)));
    for (int i = 0; i < n; i++) {
        int res = val;
        cout << res;
        if (i + 1 == n) {
            cout << "\n";
        } else {
            cout << " ";
        }
    }
    vector<vector<int>> queries;
    for (int i = 0; i < modifyQ; i++) {
        int len = rnd.wnext(n, wM);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({3, l, r});
    }
    for (int i = 0; i < sumQ; i++) {
        int len = rnd.wnext(n, wS);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({1, l, r});
    }
    for (int i = 0; i < changeQ; i++) {
        int len = rnd.wnext(n, wC);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({2, l, r, val});
    }
    shuffle(queries.begin() + modifyQ, queries.end());
    for (auto &q : queries) {
        for (size_t i = 0; i < q.size(); i++) {
            cout << q[i];
            if (i + 1 == q.size()) {
                cout << "\n";
            } else {
                cout << " ";
            }
        }
    }
}
