/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> mem(32);
	for (int i = 0; i < 32; i++) {
		for (int j = 0; j < 5; j++)
			if (i & (1 << j))
				mem[i]++;
	}
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<vector<ll>> sum(4 * n, vector<ll>(5));
	vector<ll> x(4 * n, -1), y(4 * n, -1);
	vector<int> cnt(4 * n, 0);
	function<void(int, int, int)> init = [&](int v, int l, int r) {
		if (r - l == 1) {
			sum[v][0] = a[l];
			int bit = 0;
			for (int i = 0; i < 30; i++)
				if (a[l] & (1 << i))
					bit++;
			x[v] = a[l];
			y[v] = bit;
			sum[v][1] = bit;
			for (int i = 2; i < 5; i++) {
				bit = mem[bit];
				sum[v][i] = bit;
			}
			return;
		}
		int m = (l + r) / 2;
		init(2 * v + 1, l, m);
		init(2 * v + 2, m, r);
		for (int i = 0; i < 5; i++)
			sum[v][i] = sum[2 * v + 1][i] + sum[2 * v + 2][i];
	};
	function<void(int)> update = [&](int v) {
		for (int i = 0; i < 5; i++) {
			sum[v][i] = sum[2 * v + 1][min(4, i + cnt[2 * v + 1])] + sum[2 * v + 2][min(4, i + cnt[2 * v + 2])];
		}
	};
	function<void(int, int, int)> push = [&](int v, int l, int r) {
		//cerr << v << " " << l << " " << r << endl;
		if (x[v] == -1) {
			cnt[2 * v + 1] = min(4, cnt[2 * v + 1] + cnt[v]);
			cnt[2 * v + 2] = min(4, cnt[2 * v + 2] + cnt[v]);
			cnt[v] = 0;
			return;
		}
		int m = (l + r) / 2;
		x[2 * v + 1] = x[v];
		x[2 * v + 2] = x[v];
		y[2 * v + 1] = y[v];
		y[2 * v + 2] = y[v];
		sum[2 * v + 1][0] = x[v] * (m - l);
		sum[2 * v + 2][0] = x[v] * (r - m);
		cnt[2 * v + 1] = cnt[v];
		cnt[2 * v + 2] = cnt[v];
		cnt[v] = 0;
		int z = y[v];
		x[v] = -1;
		y[v] = -1;
		for (int i = 1; i < 5; i++) {
			sum[2 * v + 1][i] = z * (m - l);
			sum[2 * v + 2][i] = z * (r - m);
			z = mem[z];
		}
	};
	function<void(int, int, int, int, int, int, int)> ins = [&](int v, int l, int r, int q, int w, int xx, int yy) {
		//cerr << v << " " << l << " " << r << " " << q << " " << w << " " << xx << " " << yy << endl;
		if (l >= w || r <= q)
			return;
		if (q <= l && r <= w) {
			x[v] = xx;
			y[v] = yy;
			sum[v][0] = x[v] * (r - l);
			cnt[v] = 0;
			int z = yy;
			for (int i = 1; i < 5; i++) {
				sum[v][i] = z * (r - l);
				z = mem[z];
			}
			return;
		}
		push(v, l, r);
		int m = (l + r) / 2;
		ins(2 * v + 1, l, m, q, w, xx, yy);
		ins(2 * v + 2, m, r, q, w, xx, yy);
		update(v);
	};
	function<void(int, int, int, int, int)> popc = [&](int v, int l, int r, int q, int w) {
		//cerr << v << " " << l << " " << r << " " << q << " " << w << endl;
		if (l >= w || r <= q)
			return;
		if (q <= l && r <= w) {
			cnt[v] = min(4, cnt[v] + 1);
			return;
		}
		push(v, l, r);
		int m = (l + r) / 2;
		popc(2 * v + 1, l, m, q, w);
		popc(2 * v + 2, m, r, q, w);
		update(v);
	};
	function<ll(int, int, int, int, int)> get = [&](int v, int l, int r, int q, int w) {
		if (l >= w || r <= q)
			return 0ll;
		if (q <= l && r <= w)
			return sum[v][cnt[v]];
		push(v, l, r);
		update(v);
		int m = (l + r) / 2;
		return get(2 * v + 1, l, m, q, w) + get(2 * v + 2, m, r, q, w);
	};
	
	init(0, 0, n);
	for (int i = 0; i < m; i++) {
		//cerr << i << endl;
		int t, l, r;
		cin >> t >> l >> r;
		l--;
		if (t == 2) {
			int xx;
			cin >> xx;
			int yy = 0;
			for (int j = 0; j < 30; j++)
				if (xx & (1 << j))
					yy++;
			ins(0, 0, n, l, r, xx, yy);
		} else if (t == 1) {
			cout << get(0, 0, n, l, r) << "\n";
		} else {
			popc(0, 0, n, l, r);
		}
	}
}
 
 
int main() {
#ifdef LOCAL
	clock_t start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}