#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item: v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

const int BITS = 32, LOGG = 8;

struct req {
    int pcnt = 0;
    int setv = 0;
    bool isset = false;
    ll total = 0;
    array<int, BITS> bitgroup;
};

int main() {

    in(int, n, q)
    vector<int> a(n);
    cin >> a;

    int d = min(n, static_cast<int>(sqrt(n)));
    int sz = n + d - 1, bcnt = sz / d;
    sz -= sz % d;
    a.resize(sz);
    vector<req> blocks(bcnt);
    for (int i = 0; i < bcnt; i++) {
        blocks[i].bitgroup.fill(0);
        int l = i * d, r = l + d;
        for (int j = l; j < r; j++) {
            blocks[i].total += a[j];
            blocks[i].bitgroup[__builtin_popcount(a[j])]++;
        }
    }

    auto set_one = [&](int bx, int ix, int x) {
        blocks[bx].bitgroup[__builtin_popcount(a[ix])]--;
        blocks[bx].bitgroup[__builtin_popcount(x)]++;
        blocks[bx].total += x - a[ix];
        a[ix] = x;
    };
    auto pcnt_one = [&](int bx, int ix) {
        int x = __builtin_popcount(a[ix]);
        set_one(bx, ix, x);
    };

    auto set_block = [&](int bx, int x) {
        blocks[bx].isset = true;
        blocks[bx].setv = x;
        blocks[bx].pcnt = 0;
        blocks[bx].bitgroup.fill(0);
        blocks[bx].bitgroup[__builtin_popcount(x)] = d;
        blocks[bx].total = static_cast<ll>(x) * d;
    };
    auto pcnt_block = [&](int bx) {
        if (blocks[bx].isset) {
            int v = __builtin_popcount(blocks[bx].setv);
            blocks[bx].bitgroup[v] = 0;
            blocks[bx].bitgroup[__builtin_popcount(v)] = d;
            blocks[bx].setv = v;
            blocks[bx].total = static_cast<ll>(v) * d;
        } else {
            blocks[bx].pcnt++;
            if (blocks[bx].pcnt > LOGG)
                return;
            blocks[bx].total = 0;
            for (int i = 0; i < BITS; i++) {
                int cnt = blocks[bx].bitgroup[i];
                blocks[bx].total += static_cast<ll>(i) * cnt;
                blocks[bx].bitgroup[__builtin_popcount(i)] += cnt;
                blocks[bx].bitgroup[i] -= cnt;
            }
        }
    };

    auto push = [&](int bx) {
        int l = bx * d, r = l + d;
        if (blocks[bx].isset) {
            for (int j = l; j < r; j++) a[j] = blocks[bx].setv;
            blocks[bx].isset = false;
        } else {
            for (int j = l; j < r; j++) {
                for (int i = 0; i < blocks[bx].pcnt && a[j]; i++)
                    a[j] = __builtin_popcount(a[j]);
            }
            blocks[bx].pcnt = 0;
        }
    };

    while (q--) {
        in(int, t, l, r)
        l--;
        if (l % d) push(l / d);
        if (r % d) push(r / d);
        int lcnt = (sz - l) % d, rcnt = r % d;

        if (t == 1) {
            ll total = 0;
            for (int i = 0; i < lcnt && l < r; i++)
                total += a[l++];
            for (int i = 0; i < rcnt && l < r; i++)
                total += a[--r];
            for (int bx = l / d; bx < r / d; bx++)
                total += blocks[bx].total;
            cout << total << '\n';
        } else if (t == 2) {
            in(int, x)
            int lbx = l / d, rbx = r / d;
            for (int i = 0; i < lcnt && l < r; i++)
                set_one(lbx, l++, x);
            for (int i = 0; i < rcnt && l < r; i++)
                set_one(rbx, --r, x);
            for (int bx = l / d; bx < r / d; bx++)
                set_block(bx, x);
        } else {
            int lbx = l / d, rbx = r / d;
            for (int i = 0; i < lcnt && l < r; i++)
                pcnt_one(lbx, l++);
            for (int i = 0; i < rcnt && l < r; i++)
                pcnt_one(rbx, --r);
            for (int bx = l / d; bx < r / d; bx++)
                pcnt_block(bx);
        }
    }

}