#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;


using ll = int;
using ld = long double;

#define X first
#define Y second

//const ll mod = 1000000007;
const ll mod = 998244353;

ll gcd(ll a, ll b)
{
    a = abs(a);
    b = abs(b);
    if (a==0 or b==0) return a+b;
    return gcd(b,a%b);
}


ll sum(ll a, ll b)
{
    a += b;
    if (a>=mod) a -= mod;
    //a %= mod;
    return a;
}

ll sub(ll a, ll b)
{
    a += mod-b;
    a %= mod;
    return a;
}

inline ll mul(ll a, ll b)
{
    if (a*b<mod) return a*b;
    else return a*b%mod;
}

inline ll pew(ll a, ll b)
{
    ll res = 1;
    while (b)
    {
        if (b&1LL) res = mul(res,a);
        a = mul(a,a);
        b >>= 1LL;
    }
    return res;
}



/*const int MOD = 998244353;
const int root = 31;
const int root_1 = 128805723;
const int root_pw = 1<<23;
const int root = 30;
const int MOD = 469762049;
const int root_1 = 15658735;
const int root_pw = 1<<26;*/


/*
void fft (vector<int> & a, bool invert) {
    int n = (int) a.size();

    for (int i=1, j=0; i<n; ++i) {
        int bit = n >> 1;
        for (; j>=bit; bit>>=1)
            j -= bit;
        j += bit;
        if (i < j)
            swap (a[i], a[j]);
    }

    for (int len=2; len<=n; len<<=1) {
        int wlen = invert ? root_1 : root;
        for (int i=len; i<root_pw; i<<=1)
            wlen = int (wlen * 1ll * wlen % mod);
        for (int i=0; i<n; i+=len) {
            int w = 1;
            for (int j=0; j<len/2; ++j) {
                int u = a[i+j],  v = int (a[i+j+len/2] * 1ll * w % mod);
                a[i+j] = u+v < mod ? u+v : u+v-mod;
                a[i+j+len/2] = u-v >= 0 ? u-v : u-v+mod;
                w = int (w * 1ll * wlen % mod);
            }
        }
    }
    if (invert) {
        int nrev = pew(n, mod-2);
        for (int i=0; i<n; ++i)
            a[i] = int (a[i] * 1ll * nrev % mod);
    }
}*/

/*
int parent[1200001];
int rnk[1200001];


void make_set (int v) {
    parent[v] = v;
    rnk[v] = 0;
}

int find_set (int v) {
    if (v == parent[v])
        return v;
    return parent[v] = find_set(parent[v]);
}

void union_sets (int a, int b) {
    a = find_set(a);
    b = find_set(b);
    if (a != b) {
        if (rnk[a] < rnk[b])
            swap(a, b);
        parent[b] = a;
        if (rnk[a] == rnk[b])
            ++rnk[a];
    }
}*/


vector<ll> a;
ll bit[32];
long long t[600000];
ll del[600000], pc[600000];
ll c[600000][32];
ll was[600000][32];
ll sz[600000];

void recalc(ll v)
{
    for (ll i=0;i<sz[v];i++) c[v][was[v][i]] = 0;
    sz[v] = 0;
    if (sz[v*2]+sz[v*2+1]>15)
    {
        t[v] = t[2*v]+t[2*v+1];
        del[v] = -1;
        pc[v] = 0;
        for (ll i=0;i<30;i++)
        {
            c[v][i] = c[v*2][i]+c[v*2+1][i];
            if (c[v][i]>0) was[v][sz[v]++] = i;
        }
        return;
    }
    ll i = 0, j = 0;
    while (i<sz[v*2] and j<sz[v*2+1])
    {
        ll x = was[v*2][i];
        ll y = was[v*2+1][j];
        if (x==y)
        {
            was[v][sz[v]++] = x;
            c[v][x] = c[v*2][x]+c[v*2+1][x];
            i++, j++;
            continue;
        }
        if (x<y)
        {
            was[v][sz[v]++] = x;
            c[v][x] = c[v*2][x];
            i++;
            continue;
        }
        was[v][sz[v]++] = y;
        c[v][y] = c[v*2+1][y];
        j++;
    }
    while (i<sz[v*2])
    {
        ll x = was[v*2][i];
        was[v][sz[v]++] = x;
        c[v][x] = c[v*2][x];
        i++;
    }
    while (j<sz[v*2+1])
    {
        ll y = was[v*2+1][j];
        was[v][sz[v]++] = y;
        c[v][y] = c[v*2+1][y];
        j++;
    }
    t[v] = t[2*v]+t[2*v+1];
    del[v] = -1;
    pc[v] = 0;
}

void build(ll v, ll tl, ll tr)
{
    if (tl==tr)
    {
        t[v] = a[tl];
        pc[v] = 0;
        del[v] = -1;
        ll B = __builtin_popcount(a[tl]);
        for (ll i=0;i<30;i++) c[v][i] = 0;
        c[v][B] = 1;
        sz[v] = 0;
        was[v][sz[v]++] = B;
        return;
    }
    ll tm = (tl+tr)/2;
    build(v*2,tl,tm);
    build(v*2+1,tm+1,tr);
    recalc(v);
}

void push(ll v, ll tl, ll tr, ll tm)
{
    vector<ll> L = {tm-tl+1,tr-tm};
    if (del[v]!=-1)
    {
        ll x = del[v];
        ll B = __builtin_popcount(x);
        for (ll z=2*v;z<=2*v+1;z++)
        {
            for (ll i=0;i<30;i++) c[z][i] = 0;
            c[z][B] = L[z-2*v];
            sz[z] = 0;
            was[z][sz[z]++] = B;
            t[z] = x*1LL*L[z-2*v];
            del[z] = x;
            pc[z] = 0;
        }
        del[v] = -1;
        return;
    }
    if (pc[v]==0) return;
    if (pc[v]>4) pc[v] = 4;
    for (ll z=2*v;z<=2*v+1;z++)
    {
        if (del[z]!=-1)
        {
            ll W = pc[v];
            ll x = del[z];
            ll prv = __builtin_popcount(x);
            while (W>0)
            {
                W--;
                x = __builtin_popcount(x);
            }
            ll B = __builtin_popcount(x);
            del[z] = x;
            c[z][prv] = 0;
            sz[z] = 0;
            was[z][sz[z]++] = B;
            c[z][B] = L[z-2*v];
            t[z] = x*1LL*L[z-2*v];
            continue;
        }
        ll W = pc[v];
        while (W>0)
        {
            W--;
            ll S = 0;
            vector<int> nxt(5);
            for (ll x=0;x<sz[z];x++)
            {
                ll i = was[z][x];
                nxt[bit[i]] += c[z][i];
                S += c[z][i]*i;
                c[z][i] = 0;
            }
            sz[z] = 0;
            for (ll i=0;i<5;i++)
            {
                if (nxt[i]!=0)
                {
                    was[z][sz[z]++] = i;
                    c[z][i] = nxt[i];
                }
            }
            t[z] = S;
        }
        pc[z] += pc[v];
    }
    pc[v] = 0;
}

ll l, r, P;
void upd0(ll v, ll tl, ll tr)
{
    if (tl>=l and tr<=r)
    {
        t[v] = P*1LL*(tr-tl+1);
        del[v] = P;
        pc[v] = 0;
        ll B = __builtin_popcount(P);
        sz[v] = 0;
        was[v][sz[v]++] = B;
        for (ll i=0;i<30;i++) c[v][i] = 0;
        c[v][B] = tr-tl+1;
        return;
    }
    ll tm = (tl+tr)/2;
    push(v,tl,tr,tm);
    if (tm>=l) upd0(v*2,tl,tm);
    if (tm<r) upd0(v*2+1,tm+1,tr);
    recalc(v);
}

void upd1(ll v, ll tl, ll tr)
{
    if (tl>=l and tr<=r)
    {
        if (del[v]!=-1)
        {
            ll x = __builtin_popcount(del[v]);
            ll B = __builtin_popcount(x);
            del[v] = x;
            for (ll i=0;i<30;i++) c[v][i] = 0;
            c[v][B] = tr-tl+1;
            sz[v] = 0;
            was[v][sz[v]++] = B;
            t[v] = x*1LL*(tr-tl+1);
            return;
        }
        if (pc[v]>=4) return;
        vector<ll> nxt(5);
        ll S = 0;
        for (ll x=0;x<sz[v];x++)
        {
            ll i = was[v][x];
            nxt[bit[i]] += c[v][i];
            S += c[v][i]*i;
            c[v][i] = 0;
        }
        sz[v] = 0;
        for (ll i=0;i<5;i++)
        {
            if (nxt[i]!=0)
            {
                was[v][sz[v]++] = i;
                c[v][i] = nxt[i];
            }
        }
        t[v] = S;
        pc[v]++;
        return;
    }
    ll tm = (tl+tr)/2;
    push(v,tl,tr,tm);
    if (tm>=l) upd1(v*2,tl,tm);
    if (tm<r) upd1(v*2+1,tm+1,tr);
    recalc(v);
}

long long get(ll v, ll tl, ll tr)
{
    if (tl>=l and tr<=r) return t[v];
    ll tm = (tl+tr)/2;
    push(v,tl,tr,tm);
    long long x = 0;
    if (tm>=l) x += get(v*2,tl,tm);
    if (tm<r) x += get(v*2+1,tm+1,tr);
    //recalc(v);
    return x;
}

void solve()
{
    ll n, q;
    cin >> n >> q;
    for (ll i=0;i<30;i++)
    {
        bit[i] = 0;
        for (ll b=0;b<5;b++) if (i&(1LL<<b)) bit[i]++;
    }
    a.resize(n);
    for (ll i=0;i<n;i++)
    {
        cin >> a[i];
    }
    build(1,0,n-1);
    while (q--)
    {
        ll T;
        cin >> T;
        ll L, R;
        cin >> L >> R;
        L--, R--;
        l = L;
        r = R;
        if (T==1) cout << get(1,0,n-1) << "\n";
        if (T==2)
        {
            ll x;
            cin >> x;
            P = x;
            upd0(1,0,n-1);
        }
        if (T==3) upd1(1,0,n-1);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll T = 1;
    while (T--) solve();
}