#include <bits/stdc++.h>
#include <string>

using namespace std;

typedef unsigned long long ull;
typedef unsigned int uint;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

typedef vector<ull> word;
uint const WORD = 64u, CHAR = 6u;

inline ull parse(char c) {
    if (c < '0') return c - '#';
    if (c <= '9') return c - '0' + 2;
    if (c <= 'Z') return c - 'A' + 12;
    return c - 'a' + 38;
}

word parse(string const &s) {
    word w{0};
    uint bx = 0;
    for (char c: s) {
        ull mask = parse(c);
        if (bx + CHAR <= WORD) {
            w.back() = w.back() << CHAR | mask;
            bx += CHAR;
        } else {
            uint lx = WORD - bx, rx = CHAR - lx;
            w.back() = w.back() << lx | mask >> rx;
            w.push_back(mask);
            bx = rx;
        }
    }
    return w;
}

bool check(word const &w1, word const &w2, uint shift) {
    uint wx = shift / WORD, bx = shift % WORD;
    for (int i = 0; i < w2.size(); i++) {
        int j1 = (i + wx) % w2.size();
        ull mask = w1[j1] << bx;
        if (bx > 0) {
            int j2 = (j1 + 1) % w2.size();
            mask |= w1[j2] >> (WORD - bx);
        }
        if (w2[i] != mask) return false;
    }
    return true;
}

int main() {

//    we don't like this stuff here, nope
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);

    in(uint, k, m)
    uint len = CHAR * k;

    while (m--) {
        in(string, c_raw, p_raw)
        word c = parse(c_raw), p = parse(p_raw);
        bool found = false;

        for (uint shift = 0; shift < len; shift++) {
            if (check(c, p, shift)) {
                cout << shift << '\n';
                found = true;
                break;
            }
        }

        if (!found) cout << -1 << '\n';
    }

}