#include "testlib.h"
#include <unordered_set>

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), m = opt<int>("m"), c = opt<int>("c");

    println(n, m, rnd.next(n) + 1);
    vector<unordered_set<int>> used_points(2);
    for (int i = 0; i < n; i++) {
        int x = -1, y;
        do {
            x = rnd.next(0, 1);
            y = rnd.next(0, c);
            if (used_points[x].find(y) != used_points[x].end()) { x = -1; }
        } while (x == -1);
        used_points[x].insert(y);
        println(x, y);
    }
    vector<unordered_set<int>> g(n);
    for (int i = 0; i < n; i++) {
        g[i].insert(i);
    }
    println("");
    for (int i = 0; i < m; i++) {
        int u = rnd.next(n);
        while (g[u].size() == n) u = (u + 1) % n;
        int v = rnd.next(n);
        while (g[u].count(v)) v = (v + 1) % n;
        g[u].insert(v);
        g[v].insert(u);
        println(u + 1, v + 1);
    }

}