#include "testlib.h"

using namespace std;

const int MAXT[] = {1000, 10, 100, 1000, 1000};
const int MAXA[] = {(int)1e9, 100, 10000, (int)1e9, (int)1e9};

bool isPrime(int n) {
	for (int i = 2; i * i <= n; i++) {
		if (n % i == 0) {
			return false;
		}
	}
	return true;
}


int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group() == "" ? -1 : validator.group()[0] - '0';

    int t = inf.readInt(1, MAXT[group], "t");
    inf.readEoln();
    
    for (int i = 0; i < t; i++) {
        setTestCase(i + 1);
    	int a = inf.readInt(2, MAXA[group], "a");
    	if (group == 3) {
    		ensuref(isPrime(a), "group 3: %d must be prime", a);
    	}
    	inf.readSpace();
    	inf.readInt(2, MAXA[group], "b");
   	    inf.readEoln();
    } 
    inf.readEof();
    
    return 0;
    
}
