#include "testlib.h"

using namespace std;


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    auto n = opt<int>("n"), sumQ = opt<int>("sq"),
            changeQ = opt<int>("cq"), modifyQ = opt<int>("mq");
    auto maxA = opt<int>("ma");
    cout << n << " " << sumQ + changeQ + modifyQ << "\n";
    for (int i = 0; i < n; i++) {
        cout << rnd.next(0, maxA);
        if (i + 1 == n) {
            cout << "\n";
        } else {
            cout << " ";
        }
    }
    vector<vector<int>> queries;
    for (int i = 0; i < sumQ; i++) {
        int l = rnd.next(1, n), r = rnd.next(1, n);
        if (l > r) {
            swap(l, r);
        }
        queries.push_back({1, l, r});
    }
    for (int i = 0; i < changeQ; i++) {
        int x = rnd.next(0, maxA);
        int l = rnd.next(1, n), r = rnd.next(1, n);
        if (l > r) {
            swap(l, r);
        }
        queries.push_back({2, l, r, x});
    }
    for (int i = 0; i < modifyQ; i++) {
        int l = rnd.next(1, n), r = rnd.next(1, n);
        if (l > r) {
            swap(l, r);
        }
        queries.push_back({3, l, r});
    }
    shuffle(queries.begin(), queries.end());
    for (auto &q : queries) {
        for (size_t i = 0; i < q.size(); i++) {
            cout << q[i];
            if (i + 1 == q.size()) {
                cout << "\n";
            } else {
                cout << " ";
            }
        }
    }
}
