#include "testlib.h"

using namespace std;


int val(int type) {
    int res = rnd.next(0, 1'000'000'000);
    if (type >= 0 && rnd.wnext(2, type)) {
        res = 0;
    }
    return res;
}


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    auto n = opt<int>("n"), q = opt<int>("q");
    auto wS = opt<int>("ws"), wM = opt<int>("wm");
    auto type = opt<int>("wz");

    cout << n << " " << q << "\n";
    for (int i = 0; i < n; i++) {
        cout << val(type);
        if (i + 1 == n) {
            cout << "\n";
        } else {
            cout << " ";
        }
    }
    auto split = rnd.partition(3, q);
    vector<vector<int>> queries;
    for (int i = 0; i < split[0]; i++) {
        int len = rnd.wnext(n, wS);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({1, l, r});
    }
    for (int i = 0; i < split[1]; i++) {
        int len = 0;
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({2, l, r, val(type)});
    }
    for (int i = 0; i < split[2]; i++) {
        int len = rnd.wnext(n, wM);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({3, l, r});
    }
    shuffle(queries.begin(), queries.end());
    for (auto &qer : queries) {
        for (size_t i = 0; i < qer.size(); i++) {
            cout << qer[i];
            if (i + 1 == qer.size()) {
                cout << "\n";
            } else {
                cout << " ";
            }
        }
    }
}
