#include "testlib.h"

using namespace std;


int val(int mz, int wZ) {
    if (mz && rnd.wnext(2, wZ)) {
        return 0;
    }
    return rnd.next(0, 20);
}


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    auto n = opt<int>("n"), q = opt<int>("q");
    auto wS = opt<int>("ws"), wM = opt<int>("wm"), wC = opt<int>("wc");
    int wZ = rnd.next(-10, 10);
    int manyZeroes = opt<int>("mz");
    auto split = rnd.partition(3, q);
    int sumQ = split[0], changeQ = split[1], modifyQ = split[2];
    cout << n << " " << sumQ + changeQ + modifyQ << "\n";
    for (int i = 0; i < n; i++) {
        int res = val(manyZeroes, wZ);
        cout << res;
        if (i + 1 == n) {
            cout << "\n";
        } else {
            cout << " ";
        }
    }
    vector<vector<int>> queries;
    for (int i = 0; i < sumQ; i++) {
        int len = rnd.wnext(n, wS);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({1, l, r});
    }
    for (int i = 0; i < changeQ; i++) {
        int len = rnd.wnext(n, wC);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({2, l, r, val(manyZeroes, wZ)});
    }
    for (int i = 0; i < modifyQ; i++) {
        int len = rnd.wnext(n, wM);
        int l = rnd.next(1, n - len), r = l + len;
        queries.push_back({3, l, r});
    }
    shuffle(queries.begin(), queries.end());
    for (auto &qur : queries) {
        for (size_t i = 0; i < qur.size(); i++) {
            cout << qur[i];
            if (i + 1 == qur.size()) {
                cout << "\n";
            } else {
                cout << " ";
            }
        }
    }
}
