#include <bits//stdc++.h>

#define ll long long
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define ld long double


const int mod = 1e9 + 9;
const int inf = 1e9 + 1;


using namespace std;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    uniform_int_distribution<ll> range(l, r);
    return range(rng);
}


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &x : arr) {
        in >> x;
    }
    return in;
}


void solve() {
    int32_t n, m;
    cin >> n >> m;
    vector<int64_t> arr(n);
    for (auto &x : arr) {
        cin >> x;
    }
    while (m--) {
        int32_t type, l, r;
        cin >> type >> l >> r;
        if (type == 1) {
            l--;
            r--;
            int64_t ans = 0;
            for (int32_t i = l; i <= r; i++) {
                ans += arr[i];
            }
            cout << ans << "\n";
        } else if (type == 2) {
            int32_t x;
            cin >> x;
            l--;
            for (int i = l; i < r; i++) {
                arr[i] = x;
            }
        } else {
            l--;
            r--;
            for (size_t i = l; i <= r; i++) {
                arr[i] = __builtin_popcount(arr[i]);
            }
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(10);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}